VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "State"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public StateName As String
Public PointX As Collection
Public PointY As Collection

Private Declare Function FloodFill Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal crColor As Long) As Long
Public Sub SelectPoint(ByVal pic As PictureBox, ByVal X As Single, ByVal Y As Single)
    If pic.Point(X, Y) = COLOR_SELECTED Then Exit Sub

    pic.FillColor = COLOR_SELECTED
    FloodFill pic.hdc, X, Y, vbBlack

    PointX.Add X
    PointY.Add Y
End Sub
Public Sub DeselectPoint(ByVal pic As PictureBox, ByVal X As Single, ByVal Y As Single)
Dim i As Integer

    pic.FillColor = COLOR_UNSELECTED
    FloodFill pic.hdc, X, Y, vbBlack

    For i = 1 To PointX.Count
        If pic.Point(PointX(i), PointY(i)) = COLOR_UNSELECTED Then
            PointX.Remove i
            PointY.Remove i
            Exit For
        End If
    Next i
End Sub
Public Function PointIsSelected(ByVal pic As PictureBox, ByVal X As Single, ByVal Y As Single)
    HighlightState pic, COLOR_SELECTED

    PointIsSelected = (pic.Point(X, Y) = COLOR_SELECTED)

    HighlightState pic, COLOR_UNSELECTED
End Function

Public Sub ReadFromFile(ByVal fnum As Integer)
Dim num_points As Integer
Dim i As Integer
Dim X As Single
Dim Y As Single

    Input #fnum, StateName, num_points
    For i = 1 To num_points
        Input #fnum, X, Y
        PointX.Add X
        PointY.Add Y
    Next i
End Sub
Public Sub HighlightState(ByVal pic As PictureBox, ByVal clr As Long)
Dim i As Integer

    pic.FillColor = clr

    For i = 1 To PointX.Count
        FloodFill pic.hdc, _
            PointX(i), PointY(i), vbBlack
    Next i
End Sub

Public Sub WriteToFile(ByVal fnum As Integer)
Dim i As Integer
Dim X As Single
Dim Y As Single

    Write #fnum, StateName, PointX.Count
    For i = 1 To PointX.Count
        Write #fnum, PointX(i), PointY(i)
    Next i
End Sub
Private Sub Class_Initialize()
    Set PointX = New Collection
    Set PointY = New Collection
End Sub


